' WinDiff.VBS V1.07 (C) yoshioka.teruo@nifty.com 2006-07-29
' WinDiff.VBS generates differential list in HTML.
' Usage: Start WinDiff.VBS file1 file2
' Usage: Start WinDiff.VBS list_file
' Usage: CScript.EXE //NoLogo WinDiff.VBS [<]list_file >htmlfile

Option Explicit
Dim wShell
Dim fso
Dim ie
Dim FileName1
Dim FileName2
Dim FileName3
Dim FileName4
Dim StdOut
Dim StdIn

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Select Case WScript.Arguments.Count()
Case 2
  FileName1=WScript.Arguments.Item(0)
  FileName2=WScript.Arguments.Item(1)
  FileName3=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetTempName())
  wShell.Run """C:\Program Files\Support Tools\WinDiff.EXE"" """&FileName1&""" """&FileName2&""" -filrx """&FileName3&"""",0,True
  Set StdIn=fso.OpenTextFile(FileName3)
Case 1
  Set StdIn=fso.OpenTextFile(WScript.Arguments.Item(0))
Case 0
  Set StdIn=WScript.StdIn
Case Else
  WScript.Echo "Usage: Start WinDiff.VBS file1 file2"&vbLf&_
               "Usage: Start WinDiff.VBS [windiff_list_file]"
  WScript.Quit
End Select

If UCase(fso.GetBaseName(WScript.FullName))="WSCRIPT" Then
  FileName4=fso.BuildPath(fso.GetSpecialFolder(2).Path,fso.GetBaseName(fso.GetTempName()) & ".HTM")
  Set StdOut=fso.CreateTextFile(FileName4)
Else
  Set StdOut=WScript.StdOut
End If
Call diff()

If Not IsEmpty(FileName3) Then
  StdIn.Close
  fso.DeleteFile FileName3
End If
If Not IsEmpty(FileName4) Then
  StdOut.Close
  Set ie=CreateObject("InternetExplorer.Application")
  ie.Visible=True
  ie.Navigate FileName4
  Do While TypeName(ie)="IWebBrowser2"
    WScript.Sleep 1000
  Loop
  fso.DeleteFile FileName4
End If

WScript.Quit

Sub diff()
Dim FileName1
Dim FileName2
Dim Line1
Dim Line3
Dim Matches
Dim LineNum1:LineNum1=0
Dim LineNum2:LineNum2=0
Dim Lines1:Lines1=Array()
Dim Lines2:Lines2=Array()
Dim k,m
Dim border
Dim width
'width="125mm"	'A4
'width="190mm"	'A3
width="50%"

Dim re1
Set re1=New RegExp
re1.Pattern="^-- (.+?) : (.+?) -- "
Rem -- FileName1 : FileName2 -- .\a.txt : .\b.txt -- includes identical,left-only,right-only, lines

Dim re2
Set re2=New RegExp
re2.Pattern="^    (.*)$"

Dim re3
Set re3=New RegExp
re3.Pattern="^ <! (.*)$"

Dim re4
Set re4=New RegExp
re4.Pattern="^ !> (.*)$"

Dim re5
Set re5=New RegExp
re5.Pattern="^-- (.*) lines listed$"

StdOut.WriteLine "<html><head>"
StdOut.WriteLine "<meta http-equiv=Content-Type content=""text/html; charset=shift_jis"">"
StdOut.WriteLine "<style><!--"
StdOut.WriteLine ".border_top{border-top:.5pt solid black;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:none;}"
StdOut.WriteLine ".border_middle{border-top:none;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:none;}"
StdOut.WriteLine ".border_bottom{border-top:none;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:.5pt solid black;}"
StdOut.WriteLine ".border_both{border-top:.5pt solid black;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:.5pt solid black;}"
StdOut.WriteLine ".border_none{border:none;}"
StdOut.WriteLine ".border_top_2{width:"&width&";word-break:break-all;border-top:.5pt solid black;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:none;}"
StdOut.WriteLine ".border_middle_2{width:"&width&";word-break:break-all;border-top:none;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:none;}"
StdOut.WriteLine ".border_bottom_2{width:"&width&";word-break:break-all;border-top:none;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:.5pt solid black;}"
StdOut.WriteLine ".border_both_2{width:"&width&";word-break:break-all;border-top:.5pt solid black;border-left:.5pt solid black;border-right:.5pt solid black;border-bottom:.5pt solid black;}"
StdOut.WriteLine ".border_none_2{width:"&width&";word-break:break-all;border:none;}"
StdOut.WriteLine "--></style></head><body><table border>"

Line3=StdIn.ReadLine
'MsgBox Line3
Set Matches=re1.Execute(Line3)
FileName1=Matches.Item(0).SubMatches.Item(0)
FileName2=Matches.Item(0).SubMatches.Item(1)
'MsgBox FileName1
'MsgBox FileName2
StdOut.WriteLine "<tr bordercolor=black><td></td><td class=border_both_2>"&FileName1&"</td><td></td><td class=border_both_2>"&FileName2&"</td></tr>"

Do While Not StdIn.AtEndOfStream
  Line3=StdIn.ReadLine
  If re3.Test(Line3) Then
    Set Matches=re3.Execute(Line3)
    Line1=Matches.Item(0).SubMatches.Item(0)
    Push Lines1,Line1
  ElseIf re4.Test(Line3) Then
    Set Matches=re4.Execute(Line3)
    Line1=Matches.Item(0).SubMatches.Item(0)
    Push Lines2,Line1
  ElseIf re2.Test(Line3) Or re5.Test(Line3) Then
    If re2.Test(Line3) Then
      Set Matches=re2.Execute(Line3)
      Line1=Matches.Item(0).SubMatches.Item(0)
'      MsgBox Line3
    Else
      Set Matches=re5.Execute(Line3)
      Line1=Matches.Item(0).SubMatches.Item(0)
'      MsgBox "! " & Line3
      Line1=Empty
    End If
    m=UBound(Lines1)
    If m<UBound(Lines2) Then m=UBound(Lines2)
    For k=0 To m
      If k=0 Then
        If k=m Then
          border="class=border_both"
        Else
          border="class=border_top"
        End If
      Else
        If k=m Then
          border="class=border_bottom"
        Else
          border="class=border_middle"
        End If
      End If
      If k<=UBound(Lines1) And k<=UBound(Lines2) Then
        LineNum1=LineNum1+1
        LineNum2=LineNum2+1
        StdOut.WriteLine "<tr><td "&border&">"&LineNum1&"</td><td "&border&"_2>"&HTMLEncode(Lines1(k))&"</td><td "&border&">"&LineNum2&"</td><td "&border&"_2>"&HTMLEncode(Lines2(k))&"</td></tr>"
      ElseIf k<=UBound(Lines1) Then
        LineNum1=LineNum1+1
        StdOut.WriteLine "<tr><td "&border&">"&LineNum1&"</td><td "&border&"_2>"&HTMLEncode(Lines1(k))&"</td><td "&border&">&nbsp;</td><td "&border&"_2>&nbsp;</td></tr>"
      Else
        LineNum2=LineNum2+1
        StdOut.WriteLine "<tr><td "&border&">&nbsp;</td><td "&border&"_2>&nbsp;</td><td "&border&">"&LineNum2&"</td><td "&border&"_2>"&HTMLEncode(Lines2(k))&"</td></tr>"
      End If
    Next
    Lines1=Array()
    Lines2=Array()

    LineNum1=LineNum1+1
    LineNum2=LineNum2+1
    border="class=border_none"
    If Not IsEmpty(Line1) Then
      StdOut.WriteLine "<tr><td "&border&">"&LineNum1&"</td><td "&border&"_2>"&HTMLEncode(Line1)&"</td><td "&border&">"&LineNum2&"</td><td "&border&"_2>"&HTMLEncode(Line1)&"</td></tr>"
    End If
  Else
    MsgBox "? " & Line3
  End If
Loop
StdOut.WriteLine "</table></body></html>"
End Sub

Function HTMLEncode(ByVal Text) 
Text=Replace(Text,"&","&amp;") 
Text=Replace(Text,">","&gt;") 
Text=Replace(Text,"<","&lt;") 
Text=Replace(Text,"""","&quot;") 
Text=Replace(Text,"'","&#39;") 
Text=Replace(Text," ","&nbsp;") 
If Text="" Then Text="&nbsp;"
HTMLEncode=Text 
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
